searchNodes=[{"doc":"Handles conversion of old block formats to newer","ref":"Mix.Tasks.Philtre.Convert.html","title":"Mix.Tasks.Philtre.Convert","type":"task"},{"doc":"","ref":"Mix.Tasks.Philtre.Convert.html#normalize/1","title":"Mix.Tasks.Philtre.Convert.normalize/1","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Philtre.Convert.html#run/1","title":"Mix.Tasks.Philtre.Convert.run/1","type":"function"},{"doc":"Defines what the structure of a block should be","ref":"Philtre.Block.html","title":"Philtre.Block","type":"behaviour"},{"doc":"Returns a list of base cells contained within the block","ref":"Philtre.Block.html#c:cells/1","title":"Philtre.Block.cells/1","type":"callback"},{"doc":"Takes the struct for the specific block type and returns its data serialized as a json-encodeable map with string keys.","ref":"Philtre.Block.html#c:data/1","title":"Philtre.Block.data/1","type":"callback"},{"doc":"Takes the struct for the specific block type and returns its id","ref":"Philtre.Block.html#c:id/1","title":"Philtre.Block.id/1","type":"callback"},{"doc":"Takes in the block id and the serialized data and returns the struct for the block.","ref":"Philtre.Block.html#c:normalize/2","title":"Philtre.Block.normalize/2","type":"callback"},{"doc":"Used to simplify and cleanup the block, remove blank fields, etc.","ref":"Philtre.Block.html#c:reduce/1","title":"Philtre.Block.reduce/1","type":"callback"},{"doc":"Renderer for the live, interactive version of the block, when editing","ref":"Philtre.Block.html#c:render_live/1","title":"Philtre.Block.render_live/1","type":"callback"},{"doc":"Renderer for the static, read-only version of the block, when rendering as plain html","ref":"Philtre.Block.html#c:render_static/1","title":"Philtre.Block.render_static/1","type":"callback"},{"doc":"Used to set a selection (focus cursor) on the block","ref":"Philtre.Block.html#c:set_selection/2","title":"Philtre.Block.set_selection/2","type":"callback"},{"doc":"Used to transform the contenteditable block into the current block","ref":"Philtre.Block.html#c:transform/1","title":"Philtre.Block.transform/1","type":"callback"},{"doc":"Takes the struct for the specific block type and returns its string type","ref":"Philtre.Block.html#c:type/1","title":"Philtre.Block.type/1","type":"callback"},{"doc":"Implements a list block Currently, the only supported form is the 1-level unordered list","ref":"Philtre.Block.List.html","title":"Philtre.Block.List","type":"module"},{"doc":"","ref":"Philtre.Block.List.html#handle_event/3","title":"Philtre.Block.List.handle_event/3","type":"function"},{"doc":"","ref":"Philtre.Block.List.html#merge/2","title":"Philtre.Block.List.merge/2","type":"function"},{"doc":"","ref":"Philtre.Block.List.html#t:t/0","title":"Philtre.Block.List.t/0","type":"type"},{"doc":"Represents a single item in the list block","ref":"Philtre.Block.List.Item.html","title":"Philtre.Block.List.Item","type":"module"},{"doc":"","ref":"Philtre.Block.List.Item.html#t:t/0","title":"Philtre.Block.List.Item.t/0","type":"type"},{"doc":"Hardcoded registry for block types. Once custom blocks are possible externally, this will be a config- or runtime registry.","ref":"Philtre.BlockRegistry.html","title":"Philtre.BlockRegistry","type":"module"},{"doc":"","ref":"Philtre.BlockRegistry.html#struct_for_type/1","title":"Philtre.BlockRegistry.struct_for_type/1","type":"function"},{"doc":"","ref":"Philtre.BlockRegistry.html#transforms/0","title":"Philtre.BlockRegistry.transforms/0","type":"function"},{"doc":"Single live component in charge of rendering all types of live blocks. Current implementation infers block type from struct module and simply delegates major callbacks to the bloc module. Later implementations might instead take block type from some sort of registry and require some sort of return format from the block modules, to decide how to render them. Ideally, we want individual blocks to be decoupled from the editor.","ref":"Philtre.LiveBlock.html","title":"Philtre.LiveBlock","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.handle_event/3 .","ref":"Philtre.LiveBlock.html#handle_event/3","title":"Philtre.LiveBlock.handle_event/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"Philtre.LiveBlock.html#render/1","title":"Philtre.LiveBlock.render/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2 .","ref":"Philtre.LiveBlock.html#update/2","title":"Philtre.LiveBlock.update/2","type":"function"},{"doc":"Static component used to render any type of block. Works in similar fashion to Philtre.LiveBlock , but in a simplified capacity.","ref":"Philtre.StaticBlock.html","title":"Philtre.StaticBlock","type":"module"},{"doc":"","ref":"Philtre.StaticBlock.html#render/1","title":"Philtre.StaticBlock.render/1","type":"function"},{"doc":"Shared component used for both creation and editing of an article.","ref":"Philtre.Editor.html","title":"Philtre.Editor","type":"module"},{"doc":"See Philtre.Editor.Serializer.html/1 .","ref":"Philtre.Editor.html#html/1","title":"Philtre.Editor.html/1","type":"function"},{"doc":"","ref":"Philtre.Editor.html#new/0","title":"Philtre.Editor.new/0","type":"function"},{"doc":"See Philtre.Editor.Serializer.normalize/1 .","ref":"Philtre.Editor.html#normalize/1","title":"Philtre.Editor.normalize/1","type":"function"},{"doc":"","ref":"Philtre.Editor.html#replace_block/3","title":"Philtre.Editor.replace_block/3","type":"function"},{"doc":"See Philtre.Editor.Serializer.serialize/1 .","ref":"Philtre.Editor.html#serialize/1","title":"Philtre.Editor.serialize/1","type":"function"},{"doc":"See Philtre.Editor.Serializer.text/1 .","ref":"Philtre.Editor.html#text/1","title":"Philtre.Editor.text/1","type":"function"},{"doc":"","ref":"Philtre.Editor.html#t:t/0","title":"Philtre.Editor.t/0","type":"type"},{"doc":"Holds shared logic for modifying editor blocks","ref":"Philtre.Editor.Engine.html","title":"Philtre.Editor.Engine","type":"module"},{"doc":"","ref":"Philtre.Editor.Engine.html#add_block/2","title":"Philtre.Editor.Engine.add_block/2","type":"function"},{"doc":"","ref":"Philtre.Editor.Engine.html#backspace_from_start/2","title":"Philtre.Editor.Engine.backspace_from_start/2","type":"function"},{"doc":"Splits block into two at cursor, then pastes in the current cliboard contents of the editor, between the two.","ref":"Philtre.Editor.Engine.html#paste/3","title":"Philtre.Editor.Engine.paste/3","type":"function"},{"doc":"Performs action of splitting a block into two separate blocks at current cursor position. This is the result of a user hitting Enter. The first block retains the type of the original. The second block is usually a P block.","ref":"Philtre.Editor.Engine.html#split_block/2","title":"Philtre.Editor.Engine.split_block/2","type":"function"},{"doc":"Performs action of spliting a block like into two lines, where both stay part of the same block. This is the result of the user usually hitting Shift + Enter.","ref":"Philtre.Editor.Engine.html#split_line/3","title":"Philtre.Editor.Engine.split_line/3","type":"function"},{"doc":"","ref":"Philtre.Editor.Engine.html#toggle_style_on_selection/3","title":"Philtre.Editor.Engine.toggle_style_on_selection/3","type":"function"},{"doc":"","ref":"Philtre.Editor.Engine.html#update/2","title":"Philtre.Editor.Engine.update/2","type":"function"},{"doc":"Holds normalization and serialization logic for the editor","ref":"Philtre.Editor.Serializer.html","title":"Philtre.Editor.Serializer","type":"module"},{"doc":"","ref":"Philtre.Editor.Serializer.html#html/1","title":"Philtre.Editor.Serializer.html/1","type":"function"},{"doc":"","ref":"Philtre.Editor.Serializer.html#normalize/1","title":"Philtre.Editor.Serializer.normalize/1","type":"function"},{"doc":"","ref":"Philtre.Editor.Serializer.html#serialize/1","title":"Philtre.Editor.Serializer.serialize/1","type":"function"},{"doc":"","ref":"Philtre.Editor.Serializer.html#text/1","title":"Philtre.Editor.Serializer.text/1","type":"function"},{"doc":"Contains various utility functions used by the library, that don't really have another place to fit in.","ref":"Philtre.Editor.Utils.html","title":"Philtre.Editor.Utils","type":"module"},{"doc":"","ref":"Philtre.Editor.Utils.html#new_id/0","title":"Philtre.Editor.Utils.new_id/0","type":"function"},{"doc":"","ref":"Philtre.Editor.Utils.html#t:id/0","title":"Philtre.Editor.Utils.id/0","type":"type"},{"doc":"Shared component used for both creation and editing of an article.","ref":"Philtre.UI.Page.html","title":"Philtre.UI.Page","type":"module"},{"doc":"","ref":"Philtre.UI.Page.html#block/1","title":"Philtre.UI.Page.block/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.handle_event/3 .","ref":"Philtre.UI.Page.html#handle_event/3","title":"Philtre.UI.Page.handle_event/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"Philtre.UI.Page.html#render/1","title":"Philtre.UI.Page.render/1","type":"function"},{"doc":"","ref":"Philtre.UI.Page.html#sidebar/1","title":"Philtre.UI.Page.sidebar/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.update/2 .","ref":"Philtre.UI.Page.html#update/2","title":"Philtre.UI.Page.update/2","type":"function"},{"doc":"Elixir-side implementation of the code-type block This block is used to write code in a synthax-highlighted UI. The frontend aspect of it is implemented in hooks/Code.ts","ref":"Philtre.Block.Code.html","title":"Philtre.Block.Code","type":"module"},{"doc":"","ref":"Philtre.Block.Code.html#handle_event/3","title":"Philtre.Block.Code.handle_event/3","type":"function"},{"doc":"","ref":"Philtre.Block.Code.html#t:t/0","title":"Philtre.Block.Code.t/0","type":"type"},{"doc":"Represents the generic contenteditable block. This block is initially created as a p block. It can be converted to other blocks by entering a markdown-like wildcard sequence at the start of the content. # to convert to &lt;h1&gt; ## to convert to &lt;h2&gt; ### to convert to &lt;h3&gt; * to convert to &lt;ul&gt; &gt; to convert to &lt;blockquote&gt; {triple backticks} to convert to &lt;pre&gt; It can also be converted to other high-level blocks. The documentation of the respective higher level block should cover how to handle such conversion. Typing backspace from the start of a content-editable block which isn't a P already converts it down to the &quot;previous&quot; block. H1 goes to H2, which goes to H3. All other blocks convert town to P. Typing backspace from the start of a P block merges it into the previous block.","ref":"Philtre.Block.ContentEditable.html","title":"Philtre.Block.ContentEditable","type":"module"},{"doc":"","ref":"Philtre.Block.ContentEditable.html#handle_event/3","title":"Philtre.Block.ContentEditable.handle_event/3","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.html#transform/2","title":"Philtre.Block.ContentEditable.transform/2","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.html#t:id/0","title":"Philtre.Block.ContentEditable.id/0","type":"type"},{"doc":"","ref":"Philtre.Block.ContentEditable.html#t:t/0","title":"Philtre.Block.ContentEditable.t/0","type":"type"},{"doc":"Implementation for a table section/component of the editor To add to editor, use /table . The current implementation starts of with a single cell, to which additional rows and cells can be added and removed from.","ref":"Philtre.Block.Table.html","title":"Philtre.Block.Table","type":"module"},{"doc":"","ref":"Philtre.Block.Table.html#handle_event/3","title":"Philtre.Block.Table.handle_event/3","type":"function"},{"doc":"Represents a single cell within a block. Cells are discrete parts of a block, to which some style (specified by modifiers) is applied. The logic of a block is such that there is no nesting of cells so everything is just one level, separated purely to support styling.","ref":"Philtre.Block.ContentEditable.Cell.html","title":"Philtre.Block.ContentEditable.Cell","type":"module"},{"doc":"","ref":"Philtre.Block.ContentEditable.Cell.html#new/0","title":"Philtre.Block.ContentEditable.Cell.new/0","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.Cell.html#normalize/1","title":"Philtre.Block.ContentEditable.Cell.normalize/1","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.Cell.html#serialize/1","title":"Philtre.Block.ContentEditable.Cell.serialize/1","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.Cell.html#t:id/0","title":"Philtre.Block.ContentEditable.Cell.id/0","type":"type"},{"doc":"","ref":"Philtre.Block.ContentEditable.Cell.html#t:t/0","title":"Philtre.Block.ContentEditable.Cell.t/0","type":"type"},{"doc":"Cleans up empty cells from a block. Various block actions will result in empty cells being left over. These are redundant and can be removed without any consequences, resulting in a simpler html.","ref":"Philtre.Block.ContentEditable.CleanEmptyCells.html","title":"Philtre.Block.ContentEditable.CleanEmptyCells","type":"module"},{"doc":"Removes empty cells from a block. Since a new block must contain an empty cell, that one is not cleaned up in this scenario. If block selection starts and/or ends within a cleaned up cell, that edge of selection is moved into the next appropriate cell.","ref":"Philtre.Block.ContentEditable.CleanEmptyCells.html#call/1","title":"Philtre.Block.ContentEditable.CleanEmptyCells.call/1","type":"function"},{"doc":"Reduces a block by merging in cells with the same styling (modifiers). The aim is to reduce the overall number of redundant cells and keep the output HTML as simple as possible.","ref":"Philtre.Block.ContentEditable.Reduce.html","title":"Philtre.Block.ContentEditable.Reduce","type":"module"},{"doc":"Reduces the block by joining neighboring cells with the same modifiers. Since selection is defined by cell ids, it needs to be updated as well.","ref":"Philtre.Block.ContentEditable.Reduce.html#call/1","title":"Philtre.Block.ContentEditable.Reduce.call/1","type":"function"},{"doc":"Holds current selection in a block. Passed from client to backend and vice-versa when executing block commands. The ids are ids of cells in which a selection starts or ends. The offests are indices within those cells where the selection starts or ends. That means a simple caret (a cursor somewhere in the block text) will have the same ids and same offsets. Similarly, a selection of a text within a single cell will have the same ids, but different offsets. Lastly, a selection across cells within a block will have different ids and different offsets. Selection across blocks is not possible. Only whole blocks can be selected and this is handled at a different level.","ref":"Philtre.Block.ContentEditable.Selection.html","title":"Philtre.Block.ContentEditable.Selection","type":"module"},{"doc":"","ref":"Philtre.Block.ContentEditable.Selection.html#new_empty/0","title":"Philtre.Block.ContentEditable.Selection.new_empty/0","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.Selection.html#new_end_of/1","title":"Philtre.Block.ContentEditable.Selection.new_end_of/1","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.Selection.html#new_start_of/1","title":"Philtre.Block.ContentEditable.Selection.new_start_of/1","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.Selection.html#normalize!/1","title":"Philtre.Block.ContentEditable.Selection.normalize!/1","type":"function"},{"doc":"","ref":"Philtre.Block.ContentEditable.Selection.html#t:t/0","title":"Philtre.Block.ContentEditable.Selection.t/0","type":"type"},{"doc":"","ref":"Playground.App.html","title":"Playground.App","type":"module"},{"doc":"","ref":"Playground.App.html#run/0","title":"Playground.App.run/0","type":"function"},{"doc":"","ref":"Playground.App.html#run_supervisor/0","title":"Playground.App.run_supervisor/0","type":"function"},{"doc":"","ref":"Playground.Controller.html","title":"Playground.Controller","type":"module"},{"doc":"","ref":"Playground.Controller.html#index/2","title":"Playground.Controller.index/2","type":"function"},{"doc":"","ref":"Playground.Controller.html#show/2","title":"Playground.Controller.show/2","type":"function"},{"doc":"Main context for storing editor content onto disk as json","ref":"Playground.Documents.html","title":"Playground.Documents","type":"module"},{"doc":"","ref":"Playground.Documents.html#delete_document/1","title":"Playground.Documents.delete_document/1","type":"function"},{"doc":"","ref":"Playground.Documents.html#get_document/1","title":"Playground.Documents.get_document/1","type":"function"},{"doc":"","ref":"Playground.Documents.html#list_documents/0","title":"Playground.Documents.list_documents/0","type":"function"},{"doc":"","ref":"Playground.Documents.html#save_document/2","title":"Playground.Documents.save_document/2","type":"function"},{"doc":"","ref":"Playground.Endpoint.html","title":"Playground.Endpoint","type":"module"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast!/3 .","ref":"Playground.Endpoint.html#broadcast!/3","title":"Playground.Endpoint.broadcast!/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast/3 .","ref":"Playground.Endpoint.html#broadcast/3","title":"Playground.Endpoint.broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from!/4 .","ref":"Playground.Endpoint.html#broadcast_from!/4","title":"Playground.Endpoint.broadcast_from!/4","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from/4 .","ref":"Playground.Endpoint.html#broadcast_from/4","title":"Playground.Endpoint.broadcast_from/4","type":"function"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Playground.Endpoint.html#call/2","title":"Playground.Endpoint.call/2","type":"function"},{"doc":"Returns the child specification to start the endpoint under a supervision tree.","ref":"Playground.Endpoint.html#child_spec/1","title":"Playground.Endpoint.child_spec/1","type":"function"},{"doc":"Returns the endpoint configuration for key Returns default if the key does not exist.","ref":"Playground.Endpoint.html#config/2","title":"Playground.Endpoint.config/2","type":"function"},{"doc":"Reloads the configuration given the application environment changes.","ref":"Playground.Endpoint.html#config_change/2","title":"Playground.Endpoint.config_change/2","type":"function"},{"doc":"Returns the host for the given endpoint.","ref":"Playground.Endpoint.html#host/0","title":"Playground.Endpoint.host/0","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Playground.Endpoint.html#init/1","title":"Playground.Endpoint.init/1","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast/3 .","ref":"Playground.Endpoint.html#local_broadcast/3","title":"Playground.Endpoint.local_broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast_from/4 .","ref":"Playground.Endpoint.html#local_broadcast_from/4","title":"Playground.Endpoint.local_broadcast_from/4","type":"function"},{"doc":"Generates the path information when routing to this endpoint.","ref":"Playground.Endpoint.html#path/1","title":"Playground.Endpoint.path/1","type":"function"},{"doc":"Generates the script name.","ref":"Playground.Endpoint.html#script_name/0","title":"Playground.Endpoint.script_name/0","type":"function"},{"doc":"Starts the endpoint supervision tree. Options :log_access_url - if the access url should be logged once the endpoint starts All other options are merged into the endpoint configuration.","ref":"Playground.Endpoint.html#start_link/1","title":"Playground.Endpoint.start_link/1","type":"function"},{"doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file in priv/static . Meant to be used for Subresource Integrity with CDNs.","ref":"Playground.Endpoint.html#static_integrity/1","title":"Playground.Endpoint.static_integrity/1","type":"function"},{"doc":"Returns a two item tuple with the first item being the static_path and the second item being the static_integrity .","ref":"Playground.Endpoint.html#static_lookup/1","title":"Playground.Endpoint.static_lookup/1","type":"function"},{"doc":"Generates a route to a static file in priv/static .","ref":"Playground.Endpoint.html#static_path/1","title":"Playground.Endpoint.static_path/1","type":"function"},{"doc":"Generates the static URL without any path information. It uses the configuration under :static_url to generate such. It falls back to :url if :static_url is not set.","ref":"Playground.Endpoint.html#static_url/0","title":"Playground.Endpoint.static_url/0","type":"function"},{"doc":"Generates the endpoint base URL but as a URI struct. It uses the configuration under :url to generate such. Useful for manipulating the URL data and passing it to URL helpers.","ref":"Playground.Endpoint.html#struct_url/0","title":"Playground.Endpoint.struct_url/0","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.subscribe/2 .","ref":"Playground.Endpoint.html#subscribe/2","title":"Playground.Endpoint.subscribe/2","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.unsubscribe/1 .","ref":"Playground.Endpoint.html#unsubscribe/1","title":"Playground.Endpoint.unsubscribe/1","type":"function"},{"doc":"Generates the endpoint base URL without any path information. It uses the configuration under :url to generate such.","ref":"Playground.Endpoint.html#url/0","title":"Playground.Endpoint.url/0","type":"function"},{"doc":"","ref":"Playground.Live.Edit.html","title":"Playground.Live.Edit","type":"module"},{"doc":"Callback implementation for Phoenix.LiveView.handle_event/3 .","ref":"Playground.Live.Edit.html#handle_event/3","title":"Playground.Live.Edit.handle_event/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.handle_info/2 .","ref":"Playground.Live.Edit.html#handle_info/2","title":"Playground.Live.Edit.handle_info/2","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.mount/3 .","ref":"Playground.Live.Edit.html#mount/3","title":"Playground.Live.Edit.mount/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.render/1 .","ref":"Playground.Live.Edit.html#render/1","title":"Playground.Live.Edit.render/1","type":"function"},{"doc":"","ref":"Playground.Live.Index.html","title":"Playground.Live.Index","type":"module"},{"doc":"Callback implementation for Phoenix.LiveView.handle_params/3 .","ref":"Playground.Live.Index.html#handle_params/3","title":"Playground.Live.Index.handle_params/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.mount/3 .","ref":"Playground.Live.Index.html#mount/3","title":"Playground.Live.Index.mount/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.render/1 .","ref":"Playground.Live.Index.html#render/1","title":"Playground.Live.Index.render/1","type":"function"},{"doc":"","ref":"Playground.Live.New.html","title":"Playground.Live.New","type":"module"},{"doc":"Callback implementation for Phoenix.LiveView.handle_event/3 .","ref":"Playground.Live.New.html#handle_event/3","title":"Playground.Live.New.handle_event/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.handle_info/2 .","ref":"Playground.Live.New.html#handle_info/2","title":"Playground.Live.New.handle_info/2","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.mount/3 .","ref":"Playground.Live.New.html#mount/3","title":"Playground.Live.New.mount/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveView.render/1 .","ref":"Playground.Live.New.html#render/1","title":"Playground.Live.New.render/1","type":"function"},{"doc":"","ref":"Playground.Router.html","title":"Playground.Router","type":"module"},{"doc":"","ref":"Playground.Router.html#browser/2","title":"Playground.Router.browser/2","type":"function"},{"doc":"Callback invoked by Plug on every request.","ref":"Playground.Router.html#call/2","title":"Playground.Router.call/2","type":"function"},{"doc":"Callback required by Plug that initializes the router for serving web requests.","ref":"Playground.Router.html#init/1","title":"Playground.Router.init/1","type":"function"},{"doc":"Module with named helpers generated from Playground.Router.","ref":"Playground.Router.Helpers.html","title":"Playground.Router.Helpers","type":"module"},{"doc":"","ref":"Playground.Router.Helpers.html#live_path/2","title":"Playground.Router.Helpers.live_path/2","type":"function"},{"doc":"","ref":"Playground.Router.Helpers.html#live_path/3","title":"Playground.Router.Helpers.live_path/3","type":"function"},{"doc":"","ref":"Playground.Router.Helpers.html#live_path/4","title":"Playground.Router.Helpers.live_path/4","type":"function"},{"doc":"","ref":"Playground.Router.Helpers.html#live_url/2","title":"Playground.Router.Helpers.live_url/2","type":"function"},{"doc":"","ref":"Playground.Router.Helpers.html#live_url/3","title":"Playground.Router.Helpers.live_url/3","type":"function"},{"doc":"","ref":"Playground.Router.Helpers.html#live_url/4","title":"Playground.Router.Helpers.live_url/4","type":"function"},{"doc":"Generates the path information including any necessary prefix.","ref":"Playground.Router.Helpers.html#path/2","title":"Playground.Router.Helpers.path/2","type":"function"},{"doc":"Generates an integrity hash to a static asset given its file path.","ref":"Playground.Router.Helpers.html#static_integrity/2","title":"Playground.Router.Helpers.static_integrity/2","type":"function"},{"doc":"Generates path to a static asset given its file path.","ref":"Playground.Router.Helpers.html#static_path/2","title":"Playground.Router.Helpers.static_path/2","type":"function"},{"doc":"Generates url to a static asset given its file path.","ref":"Playground.Router.Helpers.html#static_url/2","title":"Playground.Router.Helpers.static_url/2","type":"function"},{"doc":"Generates the connection/endpoint base URL without any path information.","ref":"Playground.Router.Helpers.html#url/1","title":"Playground.Router.Helpers.url/1","type":"function"},{"doc":"","ref":"Playground.View.html","title":"Playground.View","type":"module"},{"doc":"","ref":"Playground.View.html#render/2","title":"Playground.View.render/2","type":"function"},{"doc":"","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"A block-based content editor, with support for static html generation, in phoenix live view. Disclaimer This library is still heavily in development. Things will break and at least initially, they will not maintain backwards compatibility. In fact, the final, release-worthy version may never see the light of day. Use it at your own risk! Currently supports the following blocks: a generic content-editable wrapped which can output any of: &lt;p&gt; , &lt;h1&gt; , &lt;h2&gt; , &lt;h3&gt; , &lt;ul&gt; , &lt;pre&gt; , &lt;blockquote&gt; a very badly styled table a code block with synthax highlighting for elixir only","ref":"readme.html#description","title":"Readme - Description","type":"extras"},{"doc":"Add it to your dependencies in mix.exs : deps : [ # ... { :philtre , &quot;~&gt; 0.12.1&quot; } # ... ] Include the styles somewhere in your application, for example, from app.js : import 'philtre/dist/index.css'; Or from app.css : @import 'philtre/dist/index.css'; Import and add the necessary hooks to your live view application import * as philtreHooks from 'philtre/src/hooks'; const liveSocket = new LiveSocket('/live', Socket, { hooks: { ...philtreHooks, ...yourHooks }, }); Render the page component inside one of your live views def mount ( %{ } , _session , socket ) do { :ok , assign ( socket , %{ editor : Philtre.Editor . new ( ) } ) } end def render ( assigns ) do ~H&quot;&quot;&quot; &lt;button phx-click=&quot;save&quot;&gt;Save&lt;/button&gt; &lt;.live_component module={Philtre.UI.Page} id={@editor.id} editor={@editor} /&gt; &quot;&quot;&quot; end def handle_event ( &quot;save&quot; , %{ } , socket ) do json = Philtre.Editor . serialize ( socket . assigns . json ) # Save the json however you please # Load into editor using Philtre.Editor.normalize/1 inspect ( json ) { :noreply , socket } end def handle_info ( { :update , % Philtre.Editor { } = editor } , socket ) do { :noreply , assign ( socket , :editor , editor ) } end","ref":"readme.html#installation-and-usage","title":"Readme - Installation and Usage","type":"extras"},{"doc":"Playground is a locally setup, minimal phoenix application which loads the editor files using local paths, so they are always kept up to date and are even being watched by esbuild. THis means it allows for live-reload development of hte library. To start it, run mix playground Note that editor pages are saved as files under playground\\priv\\documents so you should probably periodically clean them.","ref":"readme.html#developing-using-playground","title":"Readme - Developing using Playground","type":"extras"},{"doc":"0.12.1 [FIX] Publish JS [DOCS] Add publishing instructions Previous version didn't incoude prebuilt js and types 0.12.0 [REWRITE] More agnostic block system where the ContentEditable is a base block through which other blocks communicate [FEATURE] Basic implementation for a list - not release-ready yet [FEATURE] Include library version in every editor","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"[FEATURE] Add Javascript support for code block [FIX] Remove block functionatliy not actually being saved unless there is a manual update to another block [FIX] Move and rename mix convert -&gt; mix philtre.convert","ref":"changelog.html#0-11-1","title":"Changelog - 0.11.1","type":"extras"},{"doc":"[FEATURE] New, more general block json format Notes A new format a block serializes into has been introduced. It's description is available in the docs, unter the outline section. A task to convert from old format into new is also available. You can use it by running mix philtre . convert path_where_your_files_are If you need to manually convert, it should also be quite straightforward, from looking at the documentation. The reason for the new format is to support more generalized block structures in the future.","ref":"changelog.html#0-11-0","title":"Changelog - 0.11.0","type":"extras"},{"doc":"[QA] Simplify Playground endpoint [QA] Reorganize e2e tests around scopes [REFACTOR] Introduce common LiveBlock component [REFACTOR] Introduce common StaticBlock component [FIX] Transform being applied to soon due to placeholder space character in new cells [QA] Add blank .credo.exs [REFACTOR] Make ContentEditable less hacky [QA] Document ContentEditable","ref":"changelog.html#0-10-2","title":"Changelog - 0.10.2","type":"extras"},{"doc":"[FIX] Adding a new empty h1, h2, h3, or li would crash [FIX] Better padding on li block [FEATURE] Shift + enter in /code block starts new block below [FEATURE] Code block auto-focuses when added [FEATURE] Navigation between blocks using tab and shift + tab [QA] Remove pageModel from integration tests [DOCS] Proposal for extensible block interface","ref":"changelog.html#0-10-1","title":"Changelog - 0.10.1","type":"extras"},{"doc":"[FEATURE] Basic code block only supporing elixir synthax highlighting [FIX] Using button to add block after a code or table block fails [QA] Improve docs [FIX] Styles for /code block were not getting included correctly","ref":"changelog.html#0-10-0","title":"Changelog - 0.10.0","type":"extras"},{"doc":"[FIX] Bug with typing after inserting new line at the end of block [CHORE] Loosen floki dependency &amp; update [CHORE] Update phoenix_live_view dependency [TWEAK] Use n to split lines in block component, instead of &lt;br/&gt; [TWEAK] Clean up redundant cells during block operations","ref":"changelog.html#0-9-4-2022-05-30","title":"Changelog - 0.9.4 2022-05-30","type":"extras"},{"doc":"fix publish + installation story","ref":"changelog.html#0-9-3-2022-05-25","title":"Changelog - 0.9.3 2022-05-25","type":"extras"},{"doc":"separate out scss into individual files style and restructure table component publish to hex and npm add basic setup readme","ref":"changelog.html#0-9-2-2022-05-22","title":"Changelog - 0.9.2 2022-05-22","type":"extras"},{"doc":"basic table component","ref":"changelog.html#0-9-0-2022-05-21","title":"Changelog - 0.9.0 2022-05-21","type":"extras"},{"doc":"various bugfixes related to blocks splitting and joining phoenix dependency update failed attempt configuration for heex formatter basic styling for PRE block","ref":"changelog.html#0-8-1-2022-05-12","title":"Changelog - 0.8.1 2022-05-12","type":"extras"},{"doc":"There have been many changes since the last update complete engine rewrite e2e test suite conversion to library support for scss various misc additions and tweaks","ref":"changelog.html#0-8-0-2022-05-08","title":"Changelog - 0.8.0 2022-05-08","type":"extras"},{"doc":"reduce blocks after backspacing or updating, so they contain a minimal amount of cells","ref":"changelog.html#0-7-1-2022-01-25","title":"Changelog - 0.7.1 2022-01-25","type":"extras"},{"doc":"blockquote further codebase simplication removal of page struct bugfixes to backspace operation","ref":"changelog.html#0-7-0-2022-01-25","title":"Changelog - 0.7.0 2022-01-25","type":"extras"},{"doc":"simplification and improvements to internal API fix for a selection bug","ref":"changelog.html#0-6-1-2022-01-19","title":"Changelog - 0.6.1 2022-01-19","type":"extras"},{"doc":"introduce esbuild via npm introduce eslint introduce prettier make topbar an npm dependency","ref":"changelog.html#0-6-0-2022-01-16","title":"Changelog - 0.6.0 2022-01-16","type":"extras"},{"doc":"update elixir to 1.13.1 + all dependencies clear up credo issues add CI action workflow documentation improvements","ref":"changelog.html#0-5-2-2022-01-08","title":"Changelog - 0.5.2 2022-01-08","type":"extras"},{"doc":"block selection feature copy paste feature cleanup known bug: typing too quickly changes cursor position","ref":"changelog.html#0-5-0-2022-01-08","title":"Changelog - 0.5.0 2022-01-08","type":"extras"},{"doc":"block + cell based editor, supporting following blocks p h1,h2,h3 ul with block downgrades, splitting, etc.","ref":"changelog.html#0-4-0-2021-11-21","title":"Changelog - 0.4.0 2021-11-21","type":"extras"},{"doc":"credo + pre-commit hook for credo dialyzer + specs + fixes + pre-commit hook for dialyzer","ref":"changelog.html#0-2-0-2021-11-07","title":"Changelog - 0.2.0 2021-11-07","type":"extras"},{"doc":"basic markdown support","ref":"changelog.html#0-2-0-2021-11-06","title":"Changelog - 0.2.0 2021-11-06","type":"extras"},{"doc":"Basic article crud and routes Slug generation and uniqueness","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Nikola Begedin Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"","ref":"outline_json_format.html","title":"Block JSON Format","type":"extras"},{"doc":"All blocks serialize into valid JSON, sharing some common structures. The editor itself, will serialize into json with a single, root field: { &quot;blocks&quot;: [] } Each individual block is then a JSON containing at minimum a type , an id and a free form data field. For example, this is what a contenteditable p block will look like: { &quot;id&quot;: &quot;7040fb6a-9e17-4c7e-a4d8-70c8427be9dc&quot;, &quot;type&quot;: &quot;contenteditable&quot;, &quot;data&quot;: { &quot;kind&quot; =&gt; &quot;p&quot;, &quot;cells&quot;: [ { &quot;id&quot;: &quot;4cdc009b-c0c0-4bc1-94d6-e353ac25afa7&quot;, &quot;modifiers&quot;: [], &quot;text&quot;: &quot;This is the title of your page&quot; } ] } } A different example, the table block, has the same root fields, but the value of data is different: { &quot;id&quot;: &quot;01de4dc5-e9bb-47db-aa90-b95760012754&quot;, &quot;type&quot;: &quot;table&quot;, &quot;data&quot; =&gt; { &quot;header_rows&quot;: [[&quot;ID&quot;, &quot;First Name&quot;, &quot;Last Name&quot;]], &quot;rows&quot;: [ [&quot;1&quot;, &quot;John&quot;, &quot;Doe&quot;], [&quot;2&quot;, &quot;Jane&quot;, &quot;Doe&quot;] ] } } Reasoning The id field serves as something to match and identify blocks across actions and changes. The type field allows the system to identify the block and properly serialize/normalize it. The data field is the actual, custom data of the block.","ref":"outline_json_format.html#current-status","title":"Block JSON Format - Current status","type":"extras"},{"doc":"","ref":"proposal_extensible_components.html","title":"Extensible Components","type":"extras"},{"doc":"Right now, each new type of section is a new module component. This keeps things contained, but not not easily managed, as every section is required to have a render function for the live version functional component for the static html version serialize function (converts component struct to JSON, ie. plain map) normalize function (converts serialized function to component struct) html function (outputs html string) series of event handlers and hooks for managing it's events","ref":"proposal_extensible_components.html#preface","title":"Extensible Components - Preface","type":"extras"},{"doc":"We introduce a single live component, called LiveBlock . This block component has a well defined interface for managing of the live component. render handle_event update etc Similarly, we introduce a StaticBlock , which has a smaller interface for rendering static content. render The existing (and later new) block types now define a module to which the LiveBlock and StaticBlock will delegate to. The delegation happens according to which blocks are registered in the app configuration. Registration In app configuration we register a block type using something like config , :philtre , :blocks , [ Philtre.Block.ContentEditable , Philtre.Block.Code , Philtre.Block.Table ] For this to work, each of the block modules also to define some additional functions, to allow the LiveBlock and StaticBlock components respecitivly, to identify where to delegate to, how to handle conversion between blocks, etc.","ref":"proposal_extensible_components.html#new-structure","title":"Extensible Components - New structure","type":"extras"},{"doc":"Will conversion between blocks using wildcards work in this system? How do we deal with blocks being merged together, split, pasted into, etc.?","ref":"proposal_extensible_components.html#questions","title":"Extensible Components - Questions","type":"extras"},{"doc":"defmodule CustomBlock do defstruct [ :id , ... ] @doc &quot;Value of the type key in the json representation, to identify the block&quot; def type , do : &quot;custom&quot; @doc &quot;Wild cards used to convert other blocks into this one&quot; def wildcards , do : [ &quot;|&gt; &quot; , &quot;/custom&quot; ] @doc &quot;Functional component to do the live render of this block&quot; def live ( assigns ) do , ~H&quot;Live renderer&quot; @doc &quot;Functional component to do the static render of this block&quot; def static ( assigns ) , do : ~H&quot;Static renderer&quot; @doc &quot;Event handler for all the events this block supports&quot; def handle_event ( type , params , socket ) @doc &quot;Converts the block module into plain map that can be serialized into json&quot; def serialize ( % __MODULE__ { } ) , do : %{ } @doc &quot;Converts plain map into module struct, idempotent with serialize&quot; def normalize ( %{ } ) , do : % __MODULE__ { } @doc &quot;Converts module to raw html string&quot; def html ( % __MODULE__ { } ) , do : &quot;Raw html string&quot; @doc &quot;Converts module to plain text-only content of the block&quot; def text ( % __MODULE__ { } ) , do : &quot;Plain text string&quot; @doc &quot;&quot;&quot; Could be used when pasting other blocks into block, or splitting the block in two for some other reason. The block would have to be in charge of encoding the position within the component, and interpreting it correctly. &quot;&quot;&quot; def split ( % __MODULE__ { } , position_in_this_component ) , do : :how? @doc &quot;&quot;&quot; Another one that&#39;s kind of unclear. Used to merge another block into this block. The block would need to know about specifics of the other block in order for this to work. We could also move the responsibility into the module of the other block, but the same problem is there. Specifics need to be known, or there needs to be some common interface. Possibly, the other block could be passed in as text or html representation. &quot;&quot;&quot; def merge ( % __MODULE__ { } , other ) end","ref":"proposal_extensible_components.html#proposed-interface-for-a-block","title":"Extensible Components - Proposed interface for a block","type":"extras"}]